/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 24 "../../smtpd/parse.y"

#include "includes.h"

#include <sys/types.h>
#include <sys/time.h>
#include <sys/queue.h>
#include <sys/tree.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <event.h>
#include <ifaddrs.h>
#include <imsg.h>
#include <inttypes.h>
#include <limits.h>
#include <netdb.h>
#ifdef HAVE_PATHS_H
#include <paths.h>
#endif
#include <pwd.h>
#include <stdarg.h>
#include <resolv.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#ifdef HAVE_UTIL_H
#include <util.h>
#endif

#include <openssl/ssl.h>

#include "smtpd.h"
#include "ssl.h"
#include "log.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 lgetc(int);
int		 lungetc(int);
int		 findeol(void);
int		 yyerror(const char *, ...)
    __attribute__((__format__ (printf, 1, 2)))
    __attribute__((__nonnull__ (1)));

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

struct smtpd		*conf = NULL;
static int		 errors = 0;

struct filter_conf	*filter = NULL;
struct table		*table = NULL;
struct rule		*rule = NULL;
struct mta_limits	*limits;
static struct pki	*pki;
static struct ca	*sca;

enum listen_options {
	LO_FAMILY	= 0x000001,
	LO_PORT		= 0x000002,
	LO_SSL		= 0x000004,
	LO_FILTER      	= 0x000008,
	LO_PKI      	= 0x000010,
	LO_AUTH      	= 0x000020,
	LO_TAG      	= 0x000040,
	LO_HOSTNAME   	= 0x000080,
	LO_HOSTNAMES   	= 0x000100,
	LO_MASKSOURCE  	= 0x000200,
	LO_NODSN	= 0x000400,
	LO_SENDERS	= 0x000800,
	LO_RECEIVEDAUTH = 0x001000,
	LO_MASQUERADE	= 0x002000,
	LO_CA		= 0x010000
};

static struct listen_opts {
	char	       *ifx;
	int		family;
	in_port_t	port;
	uint16_t	ssl;
	char	       *filtername;
	char	       *pki;
	char	       *ca;
	uint16_t       	auth;
	struct table   *authtable;
	char	       *tag;
	char	       *hostname;
	struct table   *hostnametable;
	struct table   *sendertable;
	uint16_t	flags;

	uint32_t       	options;
} listen_opts;

static struct listener	*create_sock_listener(struct listen_opts *);
static void		 create_if_listener(struct listenerlist *,  struct listen_opts *);
static void		 config_listener(struct listener *,  struct listen_opts *);

struct listener	*host_v4(const char *, in_port_t);
struct listener	*host_v6(const char *, in_port_t);
int		 host_dns(struct listenerlist *, struct listen_opts *);
int		 host(struct listenerlist *, struct listen_opts *);
int		 interface(struct listenerlist *, struct listen_opts *);
void		 set_local(const char *);
void		 set_localaddrs(struct table *);
int		 delaytonum(char *);
int		 is_if_in_group(const char *, const char *);

static struct filter_conf *create_filter_proc(char *, char *);
static struct filter_conf *create_filter_chain(char *);
static int add_filter_arg(struct filter_conf *, char *);

static int config_lo_filter(struct listen_opts *, char *);
static int config_lo_mask_source(struct listen_opts *);

typedef struct {
	union {
		int64_t		 number;
		struct table	*table;
		char		*string;
		struct host	*host;
		struct mailaddr	*maddr;
	} v;
	int lineno;
} YYSTYPE;


/* Line 371 of yacc.c  */
#line 227 "../../smtpd/parse.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     AS = 258,
     QUEUE = 259,
     COMPRESSION = 260,
     ENCRYPTION = 261,
     MAXMESSAGESIZE = 262,
     MAXMTADEFERRED = 263,
     LISTEN = 264,
     ON = 265,
     ANY = 266,
     PORT = 267,
     EXPIRE = 268,
     TABLE = 269,
     SECURE = 270,
     SMTPS = 271,
     CERTIFICATE = 272,
     DOMAIN = 273,
     BOUNCEWARN = 274,
     LIMIT = 275,
     INET4 = 276,
     INET6 = 277,
     NODSN = 278,
     SESSION = 279,
     RELAY = 280,
     BACKUP = 281,
     VIA = 282,
     DELIVER = 283,
     TO = 284,
     LMTP = 285,
     MAILDIR = 286,
     MBOX = 287,
     RCPTTO = 288,
     HOSTNAME = 289,
     HOSTNAMES = 290,
     ACCEPT = 291,
     REJECT = 292,
     INCLUDE = 293,
     ERROR = 294,
     MDA = 295,
     FROM = 296,
     FOR = 297,
     SOURCE = 298,
     MTA = 299,
     PKI = 300,
     SCHEDULER = 301,
     ARROW = 302,
     AUTH = 303,
     TLS = 304,
     LOCAL = 305,
     VIRTUAL = 306,
     TAG = 307,
     TAGGED = 308,
     ALIAS = 309,
     FILTER = 310,
     KEY = 311,
     CA = 312,
     DHE = 313,
     AUTH_OPTIONAL = 314,
     TLS_REQUIRE = 315,
     USERBASE = 316,
     SENDER = 317,
     SENDERS = 318,
     MASK_SOURCE = 319,
     VERIFY = 320,
     FORWARDONLY = 321,
     RECIPIENT = 322,
     CIPHERS = 323,
     RECEIVEDAUTH = 324,
     MASQUERADE = 325,
     SOCKET = 326,
     STRING = 327,
     NUMBER = 328
   };
#endif
/* Tokens.  */
#define AS 258
#define QUEUE 259
#define COMPRESSION 260
#define ENCRYPTION 261
#define MAXMESSAGESIZE 262
#define MAXMTADEFERRED 263
#define LISTEN 264
#define ON 265
#define ANY 266
#define PORT 267
#define EXPIRE 268
#define TABLE 269
#define SECURE 270
#define SMTPS 271
#define CERTIFICATE 272
#define DOMAIN 273
#define BOUNCEWARN 274
#define LIMIT 275
#define INET4 276
#define INET6 277
#define NODSN 278
#define SESSION 279
#define RELAY 280
#define BACKUP 281
#define VIA 282
#define DELIVER 283
#define TO 284
#define LMTP 285
#define MAILDIR 286
#define MBOX 287
#define RCPTTO 288
#define HOSTNAME 289
#define HOSTNAMES 290
#define ACCEPT 291
#define REJECT 292
#define INCLUDE 293
#define ERROR 294
#define MDA 295
#define FROM 296
#define FOR 297
#define SOURCE 298
#define MTA 299
#define PKI 300
#define SCHEDULER 301
#define ARROW 302
#define AUTH 303
#define TLS 304
#define LOCAL 305
#define VIRTUAL 306
#define TAG 307
#define TAGGED 308
#define ALIAS 309
#define FILTER 310
#define KEY 311
#define CA 312
#define DHE 313
#define AUTH_OPTIONAL 314
#define TLS_REQUIRE 315
#define USERBASE 316
#define SENDER 317
#define SENDERS 318
#define MASK_SOURCE 319
#define VERIFY 320
#define FORWARDONLY 321
#define RECIPIENT 322
#define CIPHERS 323
#define RECEIVEDAUTH 324
#define MASQUERADE 325
#define SOCKET 326
#define STRING 327
#define NUMBER 328



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 435 "../../smtpd/parse.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   238

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  82
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  82
/* YYNRULES -- Number of rules.  */
#define YYNRULES  194
/* YYNRULES -- Number of states.  */
#define YYNSTATES  298

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   328

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      74,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    81,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    76,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      79,    75,    80,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    77,     2,    78,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    11,    15,    19,    23,    27,
      31,    34,    38,    40,    42,    43,    46,    47,    50,    52,
      54,    58,    60,    64,    66,    67,    70,    73,    74,    77,
      80,    81,    83,    85,    88,    91,    92,    95,    98,    99,
     102,   104,   107,   110,   113,   116,   117,   120,   122,   124,
     126,   129,   132,   135,   137,   140,   142,   144,   146,   149,
     152,   155,   157,   159,   162,   165,   168,   171,   174,   176,
     178,   180,   183,   187,   189,   191,   194,   197,   200,   201,
     204,   205,   208,   211,   214,   217,   220,   223,   226,   228,
     230,   233,   236,   239,   240,   243,   245,   248,   251,   252,
     253,   257,   260,   263,   268,   271,   274,   277,   281,   285,
     286,   294,   295,   300,   304,   305,   310,   311,   317,   318,
     323,   324,   329,   332,   333,   334,   338,   342,   343,   350,
     352,   354,   358,   360,   364,   366,   368,   372,   374,   376,
     378,   379,   384,   388,   390,   392,   395,   398,   400,   402,
     405,   408,   409,   413,   418,   422,   428,   435,   441,   444,
     445,   451,   453,   454,   459,   463,   467,   472,   476,   480,
     484,   488,   490,   493,   495,   497,   499,   501,   503,   506,
     507,   509,   511,   514,   515,   517,   519,   520,   522,   524,
     527,   528,   529,   536,   537
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      83,     0,    -1,    -1,    83,    74,    -1,    83,    84,    74,
      -1,    83,    85,    74,    -1,    83,   117,    74,    -1,    83,
     127,    74,    -1,    83,   161,    74,    -1,    83,     1,    74,
      -1,    38,    72,    -1,    72,    75,    72,    -1,    76,    -1,
      88,    -1,    -1,    74,    87,    -1,    -1,    74,    87,    -1,
      73,    -1,    72,    -1,    53,   147,    72,    -1,    72,    -1,
      92,    76,    91,    -1,    91,    -1,    -1,    72,    73,    -1,
      95,    94,    -1,    -1,    72,    73,    -1,    93,    96,    -1,
      -1,    21,    -1,    22,    -1,    72,    73,    -1,    97,    98,
      -1,    -1,    72,    73,    -1,    99,   100,    -1,    -1,    17,
      72,    -1,   101,    -1,    17,    72,    -1,    56,    72,    -1,
      58,    72,    -1,   103,   104,    -1,    -1,    55,    72,    -1,
      64,    -1,    21,    -1,    22,    -1,    12,    72,    -1,    12,
      73,    -1,    55,    72,    -1,    16,    -1,    16,    65,    -1,
      49,    -1,    15,    -1,    60,    -1,    60,    65,    -1,    45,
      72,    -1,    57,    72,    -1,    48,    -1,    59,    -1,    48,
     138,    -1,    59,   138,    -1,    52,    72,    -1,    34,    72,
      -1,    35,   138,    -1,    64,    -1,    69,    -1,    23,    -1,
      63,   138,    -1,    63,   138,    70,    -1,   108,    -1,   109,
      -1,    71,   110,    -1,    72,   111,    -1,   105,   110,    -1,
      -1,   106,   111,    -1,    -1,     3,    72,    -1,    43,   138,
      -1,    34,    72,    -1,    35,   138,    -1,    45,    72,    -1,
      57,    72,    -1,    26,    72,    -1,    26,    -1,    49,    -1,
      49,    65,    -1,   112,   114,    -1,   113,   114,    -1,    -1,
      48,   138,    -1,    65,    -1,   112,   116,    -1,   115,   116,
      -1,    -1,    -1,    19,   118,    92,    -1,     4,     5,    -1,
       4,     6,    -1,     4,     6,    56,    72,    -1,    13,    72,
      -1,     7,    89,    -1,     8,    73,    -1,    20,    24,    94,
      -1,    20,    40,    96,    -1,    -1,    20,    44,    42,    18,
      72,   119,    98,    -1,    -1,    20,    44,   120,    98,    -1,
      20,    46,   100,    -1,    -1,     9,   121,    10,   107,    -1,
      -1,    55,    72,    72,   122,   125,    -1,    -1,    45,    72,
     123,   104,    -1,    -1,    57,    72,   124,   102,    -1,    68,
      72,    -1,    -1,    -1,    72,   126,   125,    -1,    14,    72,
      72,    -1,    -1,    14,    72,   128,    77,   134,    78,    -1,
      75,    -1,    47,    -1,    72,   129,    72,    -1,   130,    -1,
     130,    86,   131,    -1,    72,    -1,   132,    -1,   132,    86,
     133,    -1,   133,    -1,   131,    -1,    72,    -1,    -1,    77,
     136,   134,    78,    -1,    79,    72,    80,    -1,   135,    -1,
     137,    -1,    54,   138,    -1,    51,   138,    -1,   139,    -1,
     140,    -1,    61,   138,    -1,     3,    72,    -1,    -1,    28,
      29,    31,    -1,    28,    29,    31,    72,    -1,    28,    29,
      32,    -1,    28,    29,    30,    72,   143,    -1,    28,    29,
      30,    72,    33,   143,    -1,    28,    29,    40,    72,   143,
      -1,    25,   114,    -1,    -1,    25,    27,    72,   146,   116,
      -1,    81,    -1,    -1,    41,   147,    43,   138,    -1,    41,
     147,    11,    -1,    41,   147,    50,    -1,    42,   147,    18,
     138,    -1,    42,   147,    11,    -1,    42,   147,    50,    -1,
      62,   147,   138,    -1,    67,   147,   138,    -1,    66,    -1,
      13,    72,    -1,   150,    -1,   151,    -1,   148,    -1,   149,
      -1,    90,    -1,   154,   155,    -1,    -1,   142,    -1,   141,
      -1,   156,   157,    -1,    -1,   144,    -1,   145,    -1,    -1,
     153,    -1,   152,    -1,   159,   160,    -1,    -1,    -1,    36,
     162,   155,   157,   158,   160,    -1,    -1,    37,   163,   155,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   198,   198,   199,   200,   201,   202,   203,   204,   205,
     208,   223,   239,   240,   241,   244,   245,   248,   251,   258,
     271,   283,   302,   303,   304,   307,   332,   333,   336,   352,
     353,   356,   359,   362,   372,   373,   376,   398,   399,   402,
     407,   410,   413,   416,   432,   433,   436,   441,   448,   456,
     464,   482,   495,   500,   508,   516,   524,   532,   540,   548,
     556,   564,   572,   580,   589,   598,   612,   621,   637,   642,
     650,   658,   674,   692,   693,   696,   705,   711,   712,   715,
     716,   719,   744,   754,   759,   769,   784,   801,   812,   818,
     821,   826,   827,   828,   831,   842,   851,   852,   853,   856,
     856,   859,   862,   865,   874,   883,   886,   889,   890,   891,
     891,   903,   903,   906,   907,   907,   912,   912,   928,   928,
     948,   948,   968,   973,   974,   974,   982,  1019,  1019,  1027,
    1027,  1029,  1037,  1038,  1041,  1048,  1049,  1052,  1053,  1056,
    1065,  1065,  1072,  1085,  1086,  1089,  1102,  1114,  1122,  1132,
    1148,  1155,  1158,  1165,  1173,  1180,  1191,  1206,  1216,  1219,
    1219,  1238,  1239,  1242,  1257,  1265,  1275,  1290,  1298,  1308,
    1326,  1344,  1353,  1368,  1369,  1370,  1371,  1372,  1374,  1375,
    1378,  1379,  1381,  1382,  1385,  1386,  1387,  1390,  1391,  1394,
    1395,  1398,  1398,  1430,  1430
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "AS", "QUEUE", "COMPRESSION",
  "ENCRYPTION", "MAXMESSAGESIZE", "MAXMTADEFERRED", "LISTEN", "ON", "ANY",
  "PORT", "EXPIRE", "TABLE", "SECURE", "SMTPS", "CERTIFICATE", "DOMAIN",
  "BOUNCEWARN", "LIMIT", "INET4", "INET6", "NODSN", "SESSION", "RELAY",
  "BACKUP", "VIA", "DELIVER", "TO", "LMTP", "MAILDIR", "MBOX", "RCPTTO",
  "HOSTNAME", "HOSTNAMES", "ACCEPT", "REJECT", "INCLUDE", "ERROR", "MDA",
  "FROM", "FOR", "SOURCE", "MTA", "PKI", "SCHEDULER", "ARROW", "AUTH",
  "TLS", "LOCAL", "VIRTUAL", "TAG", "TAGGED", "ALIAS", "FILTER", "KEY",
  "CA", "DHE", "AUTH_OPTIONAL", "TLS_REQUIRE", "USERBASE", "SENDER",
  "SENDERS", "MASK_SOURCE", "VERIFY", "FORWARDONLY", "RECIPIENT",
  "CIPHERS", "RECEIVEDAUTH", "MASQUERADE", "SOCKET", "STRING", "NUMBER",
  "'\\n'", "'='", "','", "'{'", "'}'", "'<'", "'>'", "'!'", "$accept",
  "grammar", "include", "varset", "comma", "optnl", "nl", "size", "tagged",
  "bouncedelay", "bouncedelays", "opt_limit_mda", "limits_session",
  "opt_limit_session", "limits_mda", "opt_limit_mta", "limits_mta",
  "opt_limit_scheduler", "limits_scheduler", "opt_ca", "ca", "opt_pki",
  "pki", "opt_sock_listen", "opt_if_listen", "listener_type",
  "socket_listener", "if_listener", "sock_listen", "if_listen",
  "opt_relay_common", "opt_relay", "relay", "opt_relay_via", "relay_via",
  "main", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "filter_args",
  "$@8", "table", "$@9", "assign", "keyval", "keyval_list", "stringel",
  "string_list", "tableval_list", "tablenew", "$@10", "tableref", "tables",
  "alias", "virtual", "usermapping", "userbase", "deliver_as",
  "deliver_action", "relay_action", "$@11", "negation", "from", "for",
  "sender", "recipient", "forwardonly", "expire", "opt_decision",
  "decision", "opt_lookup", "lookup", "action", "opt_accept",
  "accept_params", "rule", "$@12", "$@13", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    10,    61,    44,   123,   125,    60,
      62,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    82,    83,    83,    83,    83,    83,    83,    83,    83,
      84,    85,    86,    86,    86,    87,    87,    88,    89,    89,
      90,    91,    92,    92,    92,    93,    94,    94,    95,    96,
      96,    97,    97,    97,    98,    98,    99,   100,   100,   101,
     102,   103,   103,   103,   104,   104,   105,   105,   106,   106,
     106,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   107,   107,   108,   109,   110,   110,   111,
     111,   112,   112,   112,   112,   112,   112,   113,   113,   113,
     113,   114,   114,   114,   115,   115,   116,   116,   116,   118,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   119,
     117,   120,   117,   117,   121,   117,   122,   117,   123,   117,
     124,   117,   117,   125,   126,   125,   127,   128,   127,   129,
     129,   130,   131,   131,   132,   133,   133,   134,   134,   135,
     136,   135,   137,   138,   138,   139,   140,   141,   141,   142,
     143,   143,   144,   144,   144,   144,   144,   144,   145,   146,
     145,   147,   147,   148,   148,   148,   149,   149,   149,   150,
     151,   152,   153,   154,   154,   154,   154,   154,   155,   155,
     156,   156,   157,   157,   158,   158,   158,   159,   159,   160,
     160,   162,   161,   163,   161
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     3,     3,     3,     3,
       2,     3,     1,     1,     0,     2,     0,     2,     1,     1,
       3,     1,     3,     1,     0,     2,     2,     0,     2,     2,
       0,     1,     1,     2,     2,     0,     2,     2,     0,     2,
       1,     2,     2,     2,     2,     0,     2,     1,     1,     1,
       2,     2,     2,     1,     2,     1,     1,     1,     2,     2,
       2,     1,     1,     2,     2,     2,     2,     2,     1,     1,
       1,     2,     3,     1,     1,     2,     2,     2,     0,     2,
       0,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       2,     2,     2,     0,     2,     1,     2,     2,     0,     0,
       3,     2,     2,     4,     2,     2,     2,     3,     3,     0,
       7,     0,     4,     3,     0,     4,     0,     5,     0,     4,
       0,     4,     2,     0,     0,     3,     3,     0,     6,     1,
       1,     3,     1,     3,     1,     1,     3,     1,     1,     1,
       0,     4,     3,     1,     1,     2,     2,     1,     1,     2,
       2,     0,     3,     4,     3,     5,     6,     5,     2,     0,
       5,     1,     0,     4,     3,     3,     4,     3,     3,     3,
       3,     1,     2,     1,     1,     1,     1,     1,     2,     0,
       1,     1,     2,     0,     1,     1,     0,     1,     1,     2,
       0,     0,     6,     0,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,   114,     0,     0,
      99,     0,   191,   193,     0,     0,     0,     0,     0,     0,
       3,     0,     0,     0,     0,     0,     9,   101,   102,    19,
      18,   105,   106,     0,   104,   127,    24,    27,    30,   111,
      38,   179,   179,    10,   118,     0,   120,   122,     0,     4,
       5,     6,     7,     8,     0,     0,   126,     0,    21,    23,
     100,     0,   107,    27,     0,    30,   108,     0,    35,     0,
      38,   113,   162,   162,   162,   162,   162,   177,   175,   176,
     173,   174,   179,   183,   194,    45,   116,     0,    11,   103,
      78,    80,   115,    73,    74,     0,     0,    28,    26,    25,
      29,     0,    31,    32,     0,    35,   112,    36,    37,   161,
       0,     0,     0,     0,     0,   178,     0,     0,     0,   147,
     148,   181,   180,   183,   186,     0,     0,     0,    45,   119,
     123,     0,    40,   121,     0,    47,    78,    75,     0,    56,
      53,    48,    49,    70,     0,     0,     0,    61,    55,     0,
       0,     0,    62,    57,     0,    68,    69,    80,    76,   134,
      14,   138,    14,   137,     0,    22,   109,    33,    34,   164,
       0,   165,   167,     0,   168,    20,   139,   140,     0,   143,
     144,   169,   170,   146,   145,   149,   182,    93,     0,   184,
     185,   190,    41,    42,    43,    44,   124,   117,    39,    46,
      77,    50,    51,    54,    66,    67,    59,    63,    65,    52,
      60,    64,    58,    71,    79,   130,   129,     0,    16,    12,
       0,    13,     0,   128,    35,   163,   166,     0,     0,     0,
      88,     0,     0,     0,     0,     0,    89,     0,    93,    93,
     158,     0,     0,   171,   188,   187,   190,   192,   123,    72,
     131,    16,    17,     0,   133,   134,   136,   110,     0,   142,
      81,    87,   159,    83,    84,    82,    85,    90,    86,    91,
      92,     0,   152,   154,     0,   172,   189,   125,    15,   141,
      98,   151,   153,   151,     0,    95,    98,    98,   160,     0,
     151,   155,   157,    94,    96,    97,   150,   156
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    21,    22,   220,   252,   221,    31,    77,    59,
      60,    65,    62,    63,    66,   105,   106,    70,    71,   132,
     133,   128,   129,   136,   157,    92,    93,    94,   137,   158,
     238,   239,   240,   287,   288,    23,    36,   224,    68,    33,
     130,    85,    87,   197,   248,    24,    57,   217,   160,   161,
     162,   163,   164,   179,   227,   180,   181,   119,   120,   121,
     122,   291,   189,   190,   280,   110,    78,    79,    80,    81,
     244,   245,    82,    83,   123,   124,   191,   246,   247,    25,
      41,    42
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -261
static const yytype_int16 yypact[] =
{
    -261,     6,  -261,   -63,    29,    44,   -49,  -261,   -26,   -20,
    -261,    26,  -261,  -261,   -14,     7,    14,    41,    55,     2,
    -261,    57,    70,    84,    88,    89,  -261,  -261,    42,  -261,
    -261,  -261,  -261,   119,  -261,    76,    93,    94,    95,   126,
      99,    97,    97,  -261,  -261,   101,  -261,  -261,   102,  -261,
    -261,  -261,  -261,  -261,   103,    69,  -261,    92,  -261,  -261,
      96,   104,  -261,    94,   105,    95,  -261,   158,    -4,   106,
      99,  -261,   107,   107,   107,   107,   107,  -261,  -261,  -261,
    -261,  -261,    97,   -22,  -261,    -9,  -261,   163,  -261,  -261,
     -19,    73,  -261,  -261,  -261,   109,    93,  -261,  -261,  -261,
    -261,   110,  -261,  -261,   111,    -4,  -261,  -261,  -261,  -261,
       5,    10,   113,    25,    25,  -261,    25,    25,    25,  -261,
    -261,  -261,  -261,   -22,    62,   114,   115,   117,    -9,  -261,
     118,   120,  -261,  -261,   121,  -261,   -19,  -261,    74,  -261,
     129,  -261,  -261,  -261,   123,    25,   124,    25,  -261,   125,
     127,   128,    25,   133,    25,  -261,  -261,    73,  -261,   -38,
      -3,  -261,    36,  -261,   130,  -261,  -261,  -261,  -261,  -261,
      25,  -261,  -261,    25,  -261,  -261,  -261,  -261,   131,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,    66,   154,  -261,
    -261,    -1,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,   132,  -261,  -261,  -261,   134,   135,  -261,
     138,  -261,   139,  -261,    -4,  -261,  -261,   109,   136,   140,
     141,   142,   143,    25,    25,   145,   153,   147,   100,   100,
    -261,    51,   148,  -261,  -261,  -261,    -1,  -261,   118,  -261,
    -261,   135,  -261,   -38,  -261,  -261,  -261,  -261,   144,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,   149,   151,  -261,   152,  -261,  -261,  -261,  -261,  -261,
      19,    24,  -261,   188,    25,  -261,    19,    19,  -261,   155,
     188,  -261,  -261,  -261,  -261,  -261,  -261,  -261
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -261,  -261,  -261,  -261,    39,   -47,  -261,  -261,  -261,   137,
    -261,  -261,   162,  -261,   161,  -261,  -100,  -261,   159,  -261,
    -261,  -261,    77,  -261,  -261,  -261,  -261,  -261,    71,    75,
    -181,  -261,   -83,  -261,  -126,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,   -18,  -261,  -261,  -261,  -261,  -261,     8,
    -261,     9,    11,  -261,  -261,  -261,  -114,  -261,  -261,  -261,
    -261,  -260,  -261,  -261,  -261,    78,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,   -41,  -261,   112,  -261,  -261,   -12,  -261,
    -261,  -261
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -136
static const yytype_int16 yytable[] =
{
     182,    84,   183,   184,   185,   168,     2,     3,   125,   215,
       4,    26,   242,     5,     6,     7,   169,   102,   103,     8,
       9,   172,   229,   292,    32,    10,    11,   289,   173,   116,
     297,   205,   117,   207,    27,    28,   134,   216,   211,   118,
     213,   115,    12,    13,    14,   135,    34,   126,   170,   127,
      37,    15,    35,   232,   233,   171,   225,   290,    43,   226,
     174,    16,   234,    17,   235,   243,    38,   284,   104,   229,
      39,   218,    40,   219,    18,  -132,   237,    48,    19,    44,
      20,   271,   272,   273,   285,   138,    45,   187,   139,   140,
     188,   274,   230,   231,   141,   142,   143,   176,    54,   286,
     232,   233,   177,   229,   178,   286,   286,   144,   145,   234,
     218,   235,   219,    46,  -135,   236,    29,    30,   146,   264,
     265,   147,   148,   237,   257,   149,   230,    47,   150,    55,
     151,    49,   152,   153,   232,   233,   154,   155,    72,    73,
      90,    91,   156,   234,    50,   235,   201,   202,    56,   236,
      74,   111,   112,   113,   114,   269,   270,   237,    51,    75,
     294,   295,    52,    53,    76,    58,    61,    64,    67,    95,
     293,    69,    96,    86,    88,    89,   101,    97,    99,   107,
     131,   159,   166,   241,   167,   175,   192,   193,   109,   194,
     196,   289,   198,   199,   203,   204,   206,   208,   212,   209,
     210,   222,   249,   228,   278,   195,   250,   200,   223,   251,
     253,   255,   260,   261,   262,   263,   259,   266,   267,   268,
     275,   281,   279,   282,   283,    98,   100,   296,   254,   108,
     277,   256,   214,   165,   276,   186,     0,     0,   258
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-261)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
     114,    42,   116,   117,   118,   105,     0,     1,    17,    47,
       4,    74,    13,     7,     8,     9,    11,    21,    22,    13,
      14,    11,     3,   283,    73,    19,    20,     3,    18,    51,
     290,   145,    54,   147,     5,     6,    55,    75,   152,    61,
     154,    82,    36,    37,    38,    64,    72,    56,    43,    58,
      24,    45,    72,    34,    35,    50,   170,    33,    72,   173,
      50,    55,    43,    57,    45,    66,    40,    48,    72,     3,
      44,    74,    46,    76,    68,    78,    57,    75,    72,    72,
      74,    30,    31,    32,    65,    12,    72,    25,    15,    16,
      28,    40,    26,    27,    21,    22,    23,    72,    56,   280,
      34,    35,    77,     3,    79,   286,   287,    34,    35,    43,
      74,    45,    76,    72,    78,    49,    72,    73,    45,   233,
     234,    48,    49,    57,   224,    52,    26,    72,    55,    10,
      57,    74,    59,    60,    34,    35,    63,    64,    41,    42,
      71,    72,    69,    43,    74,    45,    72,    73,    72,    49,
      53,    73,    74,    75,    76,   238,   239,    57,    74,    62,
     286,   287,    74,    74,    67,    72,    72,    72,    42,    77,
     284,    72,    76,    72,    72,    72,    18,    73,    73,    73,
      17,    72,    72,    29,    73,    72,    72,    72,    81,    72,
      72,     3,    72,    72,    65,    72,    72,    72,    65,    72,
      72,   162,    70,    72,   251,   128,    72,   136,    78,    74,
      72,    72,    72,    72,    72,    72,    80,    72,    65,    72,
      72,    72,    78,    72,    72,    63,    65,    72,   220,    70,
     248,   222,   157,    96,   246,   123,    -1,    -1,   227
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    83,     0,     1,     4,     7,     8,     9,    13,    14,
      19,    20,    36,    37,    38,    45,    55,    57,    68,    72,
      74,    84,    85,   117,   127,   161,    74,     5,     6,    72,
      73,    89,    73,   121,    72,    72,   118,    24,    40,    44,
      46,   162,   163,    72,    72,    72,    72,    72,    75,    74,
      74,    74,    74,    74,    56,    10,    72,   128,    72,    91,
      92,    72,    94,    95,    72,    93,    96,    42,   120,    72,
      99,   100,    41,    42,    53,    62,    67,    90,   148,   149,
     150,   151,   154,   155,   155,   123,    72,   124,    72,    72,
      71,    72,   107,   108,   109,    77,    76,    73,    94,    73,
      96,    18,    21,    22,    72,    97,    98,    73,   100,    81,
     147,   147,   147,   147,   147,   155,    51,    54,    61,   139,
     140,   141,   142,   156,   157,    17,    56,    58,   103,   104,
     122,    17,   101,   102,    55,    64,   105,   110,    12,    15,
      16,    21,    22,    23,    34,    35,    45,    48,    49,    52,
      55,    57,    59,    60,    63,    64,    69,   106,   111,    72,
     130,   131,   132,   133,   134,    91,    72,    73,    98,    11,
      43,    50,    11,    18,    50,    72,    72,    77,    79,   135,
     137,   138,   138,   138,   138,   138,   157,    25,    28,   144,
     145,   158,    72,    72,    72,   104,    72,   125,    72,    72,
     110,    72,    73,    65,    72,   138,    72,   138,    72,    72,
      72,   138,    65,   138,   111,    47,    75,   129,    74,    76,
      86,    88,    86,    78,   119,   138,   138,   136,    72,     3,
      26,    27,    34,    35,    43,    45,    49,    57,   112,   113,
     114,    29,    13,    66,   152,   153,   159,   160,   126,    70,
      72,    74,    87,    72,   131,    72,   133,    98,   134,    80,
      72,    72,    72,    72,   138,   138,    72,    65,    72,   114,
     114,    30,    31,    32,    40,    72,   160,   125,    87,    78,
     146,    72,    72,    72,    48,    65,   112,   115,   116,     3,
      33,   143,   143,   138,   116,   116,    72,   143
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 9:
/* Line 1792 of yacc.c  */
#line 205 "../../smtpd/parse.y"
    { file->errors++; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 208 "../../smtpd/parse.y"
    {
			struct file	*nfile;

			if ((nfile = pushfile((yyvsp[(2) - (2)].v.string), 0)) == NULL) {
				yyerror("failed to include file %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));

			file = nfile;
			lungetc('\n');
		}
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 223 "../../smtpd/parse.y"
    {
			char *s = (yyvsp[(1) - (3)].v.string);
			while (*s++) {
				if (isspace((unsigned char)*s)) {
					yyerror("macro name cannot contain "
					    "whitespace");
					YYERROR;
				}
			}
			if (symset((yyvsp[(1) - (3)].v.string), (yyvsp[(3) - (3)].v.string), 0) == -1)
				fatal("cannot store variable");
			free((yyvsp[(1) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 251 "../../smtpd/parse.y"
    {
			if ((yyvsp[(1) - (1)].v.number) < 0) {
				yyerror("invalid size: %" PRId64, (yyvsp[(1) - (1)].v.number));
				YYERROR;
			}
			(yyval.v.number) = (yyvsp[(1) - (1)].v.number);
		}
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 258 "../../smtpd/parse.y"
    {
			long long result;

			if (scan_scaled((yyvsp[(1) - (1)].v.string), &result) == -1 || result < 0) {
				yyerror("invalid size: %s", (yyvsp[(1) - (1)].v.string));
				free((yyvsp[(1) - (1)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (1)].v.string));
			(yyval.v.number) = result;
		}
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 271 "../../smtpd/parse.y"
    {
			if (strlcpy(rule->r_tag, (yyvsp[(3) - (3)].v.string), sizeof rule->r_tag)
			    >= sizeof rule->r_tag) {
				yyerror("tag name too long: %s", (yyvsp[(3) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(3) - (3)].v.string));
			rule->r_nottag = (yyvsp[(2) - (3)].v.number);
		}
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 283 "../../smtpd/parse.y"
    {
			time_t	d;
			int	i;

			d = delaytonum((yyvsp[(1) - (1)].v.string));
			if (d < 0) {
				yyerror("invalid bounce delay: %s", (yyvsp[(1) - (1)].v.string));
				free((yyvsp[(1) - (1)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (1)].v.string));
			for (i = 0; i < MAX_BOUNCE_WARN; i++) {
				if (conf->sc_bounce_warn[i] != 0)
					continue;
				conf->sc_bounce_warn[i] = d;
				break;
			}
		}
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 307 "../../smtpd/parse.y"
    {
			if (!strcmp((yyvsp[(1) - (2)].v.string), "max-session")) {
				conf->sc_mda_max_session = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "max-session-per-user")) {
				conf->sc_mda_max_user_session = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "task-lowat")) {
				conf->sc_mda_task_lowat = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "task-hiwat")) {
				conf->sc_mda_task_hiwat = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "task-release")) {
				conf->sc_mda_task_release = (yyvsp[(2) - (2)].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[(1) - (2)].v.string));
				free((yyvsp[(1) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (2)].v.string));
		}
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 336 "../../smtpd/parse.y"
    {
			if (!strcmp((yyvsp[(1) - (2)].v.string), "max-rcpt")) {
				conf->sc_session_max_rcpt = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "max-mails")) {
				conf->sc_session_max_mails = (yyvsp[(2) - (2)].v.number);
			}
			else {
				yyerror("invalid session limit keyword: %s", (yyvsp[(1) - (2)].v.string));
				free((yyvsp[(1) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (2)].v.string));
		}
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 356 "../../smtpd/parse.y"
    {
			limits->family = AF_INET;
		}
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 359 "../../smtpd/parse.y"
    {
			limits->family = AF_INET6;
		}
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 362 "../../smtpd/parse.y"
    {
			if (!limit_mta_set(limits, (yyvsp[(1) - (2)].v.string), (yyvsp[(2) - (2)].v.number))) {
				yyerror("invalid mta limit keyword: %s", (yyvsp[(1) - (2)].v.string));
				free((yyvsp[(1) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (2)].v.string));
		}
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 376 "../../smtpd/parse.y"
    {
			if (!strcmp((yyvsp[(1) - (2)].v.string), "max-inflight")) {
				conf->sc_scheduler_max_inflight = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "max-evp-batch-size")) {
				conf->sc_scheduler_max_evp_batch_size = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "max-msg-batch-size")) {
				conf->sc_scheduler_max_msg_batch_size = (yyvsp[(2) - (2)].v.number);
			}
			else if (!strcmp((yyvsp[(1) - (2)].v.string), "max-schedule")) {
				conf->sc_scheduler_max_schedule = (yyvsp[(2) - (2)].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[(1) - (2)].v.string));
				free((yyvsp[(1) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (2)].v.string));
		}
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 402 "../../smtpd/parse.y"
    {
			sca->ca_cert_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 410 "../../smtpd/parse.y"
    {
			pki->pki_cert_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 413 "../../smtpd/parse.y"
    {
			pki->pki_key_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 416 "../../smtpd/parse.y"
    {
			if (strcasecmp((yyvsp[(2) - (2)].v.string), "none") == 0)
				pki->pki_dhe = 0;
			else if (strcasecmp((yyvsp[(2) - (2)].v.string), "auto") == 0)
				pki->pki_dhe = 1;
			else if (strcasecmp((yyvsp[(2) - (2)].v.string), "legacy") == 0)
				pki->pki_dhe = 2;
			else {
				yyerror("invalid DHE keyword: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 436 "../../smtpd/parse.y"
    {
			if (config_lo_filter(&listen_opts, (yyvsp[(2) - (2)].v.string))) {
				YYERROR;
			}
		}
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 441 "../../smtpd/parse.y"
    {
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 448 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET;
		}
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 456 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET6;
		}
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 464 "../../smtpd/parse.y"
    {
			struct servent	*servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname((yyvsp[(2) - (2)].v.string), "tcp");
			if (servent == NULL) {
				yyerror("invalid port: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
			listen_opts.port = ntohs(servent->s_port);
		}
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 482 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			if ((yyvsp[(2) - (2)].v.number) <= 0 || (yyvsp[(2) - (2)].v.number) >= (int)USHRT_MAX) {
				yyerror("invalid port: %" PRId64, (yyvsp[(2) - (2)].v.number));
				YYERROR;
			}
			listen_opts.port = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 495 "../../smtpd/parse.y"
    {
			if (config_lo_filter(&listen_opts, (yyvsp[(2) - (2)].v.string))) {
				YYERROR;
			}
		}
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 500 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS;
		}
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 508 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS|F_TLS_VERIFY;
		}
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 516 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS;
		}
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 524 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SSL;
		}
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 532 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE;
		}
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 540 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE|F_TLS_VERIFY;
		}
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 548 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_PKI) {
				yyerror("pki already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PKI;
			listen_opts.pki = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 556 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_CA) {
				yyerror("ca already specified");
				YYERROR;
			}
			listen_opts.options |= LO_CA;
			listen_opts.ca = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 564 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 572 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH;
		}
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 580 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[(2) - (2)].v.table);
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 589 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[(2) - (2)].v.table);
			listen_opts.auth = F_AUTH;
		}
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 598 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_TAG) {
				yyerror("tag already specified");
				YYERROR;
			}
			listen_opts.options |= LO_TAG;

			if (strlen((yyvsp[(2) - (2)].v.string)) >= SMTPD_TAG_SIZE) {
       				yyerror("tag name too long");
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			listen_opts.tag = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 612 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_HOSTNAME) {
				yyerror("hostname already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAME;

			listen_opts.hostname = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 621 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);

			if (listen_opts.options & LO_HOSTNAMES) {
				yyerror("hostnames already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAMES;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			listen_opts.hostnametable = t;
		}
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 637 "../../smtpd/parse.y"
    {
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 642 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_RECEIVEDAUTH) {
				yyerror("received-auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_RECEIVEDAUTH;
			listen_opts.flags |= F_RECEIVEDAUTH;
		}
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 650 "../../smtpd/parse.y"
    {
			if (listen_opts.options & LO_NODSN) {
				yyerror("no-dsn already specified");
				YYERROR;
			}
			listen_opts.options |= LO_NODSN;
			listen_opts.flags &= ~F_EXT_DSN;
		}
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 658 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 674 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (3)].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS|LO_MASQUERADE;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 696 "../../smtpd/parse.y"
    {
			if (conf->sc_sock_listener) {
				yyerror("socket listener already configured");
				YYERROR;
			}
			conf->sc_sock_listener = create_sock_listener(&listen_opts);
		}
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 705 "../../smtpd/parse.y"
    {
			listen_opts.ifx = (yyvsp[(1) - (2)].v.string);
			create_if_listener(conf->sc_listeners, &listen_opts);
		}
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 719 "../../smtpd/parse.y"
    {
			struct mailaddr maddr, *maddrp;

			if (!text_to_mailaddr(&maddr, (yyvsp[(2) - (2)].v.string))) {
				yyerror("invalid parameter to AS: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));

			if (maddr.user[0] == '\0' && maddr.domain[0] == '\0') {
				yyerror("invalid empty parameter to AS");
				YYERROR;
			}
			else if (maddr.domain[0] == '\0') {
				if (strlcpy(maddr.domain, conf->sc_hostname,
					sizeof (maddr.domain))
				    >= sizeof (maddr.domain)) {
					yyerror("hostname too long for AS parameter: %s",
					    conf->sc_hostname);
					YYERROR;
				}
			}
			rule->r_as = xmemdup(&maddr, sizeof (*maddrp), "parse relay_as: AS");
		}
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 744 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);
			if (!table_check_use(t, T_DYNAMIC|T_LIST, K_SOURCE)) {
				yyerror("invalid use of table \"%s\" as "
				    "SOURCE parameter", t->t_name);
				YYERROR;
			}
			(void)strlcpy(rule->r_value.relayhost.sourcetable, t->t_name,
			    sizeof rule->r_value.relayhost.sourcetable);
		}
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 754 "../../smtpd/parse.y"
    {
			(void)strlcpy(rule->r_value.relayhost.heloname, (yyvsp[(2) - (2)].v.string),
			    sizeof rule->r_value.relayhost.heloname);
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 759 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);
			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			(void)strlcpy(rule->r_value.relayhost.helotable, t->t_name,
			    sizeof rule->r_value.relayhost.helotable);
		}
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 769 "../../smtpd/parse.y"
    {
			if (!lowercase(rule->r_value.relayhost.pki_name, (yyvsp[(2) - (2)].v.string),
				sizeof(rule->r_value.relayhost.pki_name))) {
				yyerror("pki name too long: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			if (dict_get(conf->sc_pki_dict,
				rule->r_value.relayhost.pki_name) == NULL) {
				log_warnx("pki name not found: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 784 "../../smtpd/parse.y"
    {
			if (!lowercase(rule->r_value.relayhost.ca_name, (yyvsp[(2) - (2)].v.string),
				sizeof(rule->r_value.relayhost.ca_name))) {
				yyerror("ca name too long: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			if (dict_get(conf->sc_ca_dict,
				rule->r_value.relayhost.ca_name) == NULL) {
				log_warnx("ca name not found: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 801 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_BACKUP;
			if (strlcpy(rule->r_value.relayhost.hostname, (yyvsp[(2) - (2)].v.string),
				sizeof (rule->r_value.relayhost.hostname))
			    >= sizeof (rule->r_value.relayhost.hostname)) {
				log_warnx("hostname too long: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 812 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_BACKUP;
			(void)strlcpy(rule->r_value.relayhost.hostname,
			    conf->sc_hostname,
			    sizeof (rule->r_value.relayhost.hostname));
		}
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 818 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_STARTTLS;
		}
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 821 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_STARTTLS|F_TLS_VERIFY;
		}
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 831 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_CREDENTIALS)) {
				yyerror("invalid use of table \"%s\" as AUTH parameter",
				    t->t_name);
				YYERROR;
			}
			(void)strlcpy(rule->r_value.relayhost.authtable, t->t_name,
			    sizeof(rule->r_value.relayhost.authtable));
		}
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 842 "../../smtpd/parse.y"
    {
			if (!(rule->r_value.relayhost.flags & F_SSL)) {
				yyerror("cannot \"verify\" with insecure protocol");
				YYERROR;
			}
			rule->r_value.relayhost.flags |= F_TLS_VERIFY;
		}
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 856 "../../smtpd/parse.y"
    {
			memset(conf->sc_bounce_warn, 0, sizeof conf->sc_bounce_warn);
		}
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 859 "../../smtpd/parse.y"
    {
			conf->sc_queue_flags |= QUEUE_COMPRESSION;
		}
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 862 "../../smtpd/parse.y"
    {
			conf->sc_queue_flags |= QUEUE_ENCRYPTION;
		}
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 865 "../../smtpd/parse.y"
    {
			if (strcasecmp((yyvsp[(4) - (4)].v.string), "stdin") == 0 || strcasecmp((yyvsp[(4) - (4)].v.string), "-") == 0) {
				conf->sc_queue_key = "stdin";
				free((yyvsp[(4) - (4)].v.string));
			}
			else
				conf->sc_queue_key = (yyvsp[(4) - (4)].v.string);
			conf->sc_queue_flags |= QUEUE_ENCRYPTION;
		}
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 874 "../../smtpd/parse.y"
    {
			conf->sc_qexpire = delaytonum((yyvsp[(2) - (2)].v.string));
			if (conf->sc_qexpire == -1) {
				yyerror("invalid expire delay: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 883 "../../smtpd/parse.y"
    {
			conf->sc_maxsize = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 886 "../../smtpd/parse.y"
    {
			conf->sc_mta_max_deferred = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 891 "../../smtpd/parse.y"
    {
			struct mta_limits	*d;

			limits = dict_get(conf->sc_limits_dict, (yyvsp[(5) - (5)].v.string));
			if (limits == NULL) {
				limits = xcalloc(1, sizeof(*limits), "mta_limits");
				dict_xset(conf->sc_limits_dict, (yyvsp[(5) - (5)].v.string), limits);
				d = dict_xget(conf->sc_limits_dict, "default");
				memmove(limits, d, sizeof(*limits));
			}
			free((yyvsp[(5) - (5)].v.string));
		}
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 903 "../../smtpd/parse.y"
    {
			limits = dict_get(conf->sc_limits_dict, "default");
		}
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 907 "../../smtpd/parse.y"
    {
			memset(&listen_opts, 0, sizeof listen_opts);
			listen_opts.family = AF_UNSPEC;
			listen_opts.flags |= F_EXT_DSN;
		}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 912 "../../smtpd/parse.y"
    {
			if (!strcmp((yyvsp[(3) - (3)].v.string), "chain")) {
				free((yyvsp[(3) - (3)].v.string));
				if ((filter = create_filter_chain((yyvsp[(2) - (3)].v.string))) == NULL) {
					free((yyvsp[(2) - (3)].v.string));
					YYERROR;
				}
			}
			else {
				if ((filter = create_filter_proc((yyvsp[(2) - (3)].v.string), (yyvsp[(3) - (3)].v.string))) == NULL) {
					free((yyvsp[(2) - (3)].v.string));
					free((yyvsp[(3) - (3)].v.string));
					YYERROR;
				}
			}
		}
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 928 "../../smtpd/parse.y"
    {
			char buf[HOST_NAME_MAX+1];

			/* if not catchall, check that it is a valid domain */
			if (strcmp((yyvsp[(2) - (2)].v.string), "*") != 0) {
				if (!res_hnok((yyvsp[(2) - (2)].v.string))) {
					yyerror("not a valid domain name: %s", (yyvsp[(2) - (2)].v.string));
					free((yyvsp[(2) - (2)].v.string));
					YYERROR;
				}
			}
			xlowercase(buf, (yyvsp[(2) - (2)].v.string), sizeof(buf));
			free((yyvsp[(2) - (2)].v.string));
			pki = dict_get(conf->sc_pki_dict, buf);
			if (pki == NULL) {
				pki = xcalloc(1, sizeof *pki, "parse:pki");
				(void)strlcpy(pki->pki_name, buf, sizeof(pki->pki_name));
				dict_set(conf->sc_pki_dict, pki->pki_name, pki);
			}
		}
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 948 "../../smtpd/parse.y"
    {
			char buf[HOST_NAME_MAX+1];

			/* if not catchall, check that it is a valid domain */
			if (strcmp((yyvsp[(2) - (2)].v.string), "*") != 0) {
				if (!res_hnok((yyvsp[(2) - (2)].v.string))) {
					yyerror("not a valid domain name: %s", (yyvsp[(2) - (2)].v.string));
					free((yyvsp[(2) - (2)].v.string));
					YYERROR;
				}
			}
			xlowercase(buf, (yyvsp[(2) - (2)].v.string), sizeof(buf));
			free((yyvsp[(2) - (2)].v.string));
			sca = dict_get(conf->sc_ca_dict, buf);
			if (sca == NULL) {
				sca = xcalloc(1, sizeof *sca, "parse:ca");
				(void)strlcpy(sca->ca_name, buf, sizeof(sca->ca_name));
				dict_set(conf->sc_ca_dict, sca->ca_name, sca);
			}
		}
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 968 "../../smtpd/parse.y"
    {
			env->sc_tls_ciphers = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 974 "../../smtpd/parse.y"
    {
			if (!add_filter_arg(filter, (yyvsp[(1) - (1)].v.string))) {
				free((yyvsp[(1) - (1)].v.string));
				YYERROR;
			}
		}
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 982 "../../smtpd/parse.y"
    {
			char *p, *backend, *config;

			p = (yyvsp[(3) - (3)].v.string);
			if (*p == '/') {
				backend = "static";
				config = (yyvsp[(3) - (3)].v.string);
			}
			else {
				backend = (yyvsp[(3) - (3)].v.string);
				config = NULL;
				for (p = (yyvsp[(3) - (3)].v.string); *p && *p != ':'; p++)
					;
				if (*p == ':') {
					*p = '\0';
					backend = (yyvsp[(3) - (3)].v.string);
					config  = p+1;
				}
			}
			if (config != NULL && *config != '/') {
				yyerror("invalid backend parameter for table: %s",
				    (yyvsp[(2) - (3)].v.string));
				free((yyvsp[(2) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			table = table_create(backend, (yyvsp[(2) - (3)].v.string), NULL, config);
			if (!table_config(table)) {
				yyerror("invalid configuration file %s for table %s",
				    config, table->t_name);
				free((yyvsp[(2) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1019 "../../smtpd/parse.y"
    {
			table = table_create("static", (yyvsp[(2) - (2)].v.string), NULL, NULL);
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1022 "../../smtpd/parse.y"
    {
			table = NULL;
		}
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1029 "../../smtpd/parse.y"
    {
			table->t_type = T_HASH;
			table_add(table, (yyvsp[(1) - (3)].v.string), (yyvsp[(3) - (3)].v.string));
			free((yyvsp[(1) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1041 "../../smtpd/parse.y"
    {
			table->t_type = T_LIST;
			table_add(table, (yyvsp[(1) - (1)].v.string), NULL);
			free((yyvsp[(1) - (1)].v.string));
		}
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1052 "../../smtpd/parse.y"
    { }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1053 "../../smtpd/parse.y"
    { }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1056 "../../smtpd/parse.y"
    {
			struct table	*t;

			t = table_create("static", NULL, NULL, NULL);
			t->t_type = T_LIST;
			table_add(t, (yyvsp[(1) - (1)].v.string), NULL);
			free((yyvsp[(1) - (1)].v.string));
			(yyval.v.table) = t;
		}
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1065 "../../smtpd/parse.y"
    {
			table = table_create("static", NULL, NULL, NULL);
		}
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1067 "../../smtpd/parse.y"
    {
			(yyval.v.table) = table;
		}
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1072 "../../smtpd/parse.y"
    {
			struct table	*t;

			if ((t = table_find((yyvsp[(2) - (3)].v.string), NULL)) == NULL) {
				yyerror("no such table: %s", (yyvsp[(2) - (3)].v.string));
				free((yyvsp[(2) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (3)].v.string));
			(yyval.v.table) = t;
		}
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1085 "../../smtpd/parse.y"
    { (yyval.v.table) = (yyvsp[(1) - (1)].v.table); }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1086 "../../smtpd/parse.y"
    { (yyval.v.table) = (yyvsp[(1) - (1)].v.table); }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1089 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
				yyerror("invalid use of table \"%s\" as ALIAS parameter",
				    t->t_name);
				YYERROR;
			}

			(yyval.v.table) = t;
		}
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1102 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
				yyerror("invalid use of table \"%s\" as VIRTUAL parameter",
				    t->t_name);
				YYERROR;
			}
			(yyval.v.table) = t;
		}
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1114 "../../smtpd/parse.y"
    {
			if (rule->r_mapping) {
				yyerror("alias specified multiple times");
				YYERROR;
			}
			rule->r_desttype = DEST_DOM;
			rule->r_mapping = (yyvsp[(1) - (1)].v.table);
		}
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1122 "../../smtpd/parse.y"
    {
			if (rule->r_mapping) {
				yyerror("virtual specified multiple times");
				YYERROR;
			}
			rule->r_desttype = DEST_VDOM;
			rule->r_mapping = (yyvsp[(1) - (1)].v.table);
		}
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1132 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (rule->r_userbase) {
				yyerror("userbase specified multiple times");
				YYERROR;
			}
			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_USERINFO)) {
				yyerror("invalid use of table \"%s\" as USERBASE parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_userbase = t;
		}
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1148 "../../smtpd/parse.y"
    {
			if (strlcpy(rule->r_delivery_user, (yyvsp[(2) - (2)].v.string),
			    sizeof(rule->r_delivery_user))
			    >= sizeof(rule->r_delivery_user))
				fatal("username too long");
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1155 "../../smtpd/parse.y"
    {}
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1158 "../../smtpd/parse.y"
    {
			rule->r_action = A_MAILDIR;
			if (strlcpy(rule->r_value.buffer, "~/Maildir",
			    sizeof(rule->r_value.buffer)) >=
			    sizeof(rule->r_value.buffer))
				fatal("pathname too long");
		}
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1165 "../../smtpd/parse.y"
    {
			rule->r_action = A_MAILDIR;
			if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (4)].v.string),
			    sizeof(rule->r_value.buffer)) >=
			    sizeof(rule->r_value.buffer))
				fatal("pathname too long");
			free((yyvsp[(4) - (4)].v.string));
		}
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1173 "../../smtpd/parse.y"
    {
			rule->r_action = A_MBOX;
			if (strlcpy(rule->r_value.buffer, _PATH_MAILDIR "/%u",
			    sizeof(rule->r_value.buffer))
			    >= sizeof(rule->r_value.buffer))
				fatal("pathname too long");
		}
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1180 "../../smtpd/parse.y"
    {
			rule->r_action = A_LMTP;
			if (strchr((yyvsp[(4) - (5)].v.string), ':') || (yyvsp[(4) - (5)].v.string)[0] == '/') {
				if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (5)].v.string),
					sizeof(rule->r_value.buffer))
					>= sizeof(rule->r_value.buffer))
					fatal("lmtp destination too long");
			} else
				fatal("invalid lmtp destination");
			free((yyvsp[(4) - (5)].v.string));
		}
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1191 "../../smtpd/parse.y"
    {
			rule->r_action = A_LMTP;
			if (strchr((yyvsp[(4) - (6)].v.string), ':') || (yyvsp[(4) - (6)].v.string)[0] == '/') {
				if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (6)].v.string),
					sizeof(rule->r_value.buffer))
					>= sizeof(rule->r_value.buffer))
					fatal("lmtp destination too long");
				if (strlcat(rule->r_value.buffer, " rcpt-to",
					sizeof(rule->r_value.buffer))
					>= sizeof(rule->r_value.buffer))
					fatal("lmtp recipient too long");
			} else
				fatal("invalid lmtp destination");
			free((yyvsp[(4) - (6)].v.string));
		}
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1206 "../../smtpd/parse.y"
    {
			rule->r_action = A_MDA;
			if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (5)].v.string),
			    sizeof(rule->r_value.buffer))
			    >= sizeof(rule->r_value.buffer))
				fatal("command too long");
			free((yyvsp[(4) - (5)].v.string));
		}
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 1216 "../../smtpd/parse.y"
    {
			rule->r_action = A_RELAY;
		}
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1219 "../../smtpd/parse.y"
    {
			rule->r_action = A_RELAYVIA;
			if (!text_to_relayhost(&rule->r_value.relayhost, (yyvsp[(3) - (3)].v.string))) {
				yyerror("error: invalid url: %s", (yyvsp[(3) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1227 "../../smtpd/parse.y"
    {
			/* no worries, F_AUTH cant be set without SSL */
			if (rule->r_value.relayhost.flags & F_AUTH) {
				if (rule->r_value.relayhost.authtable[0] == '\0') {
					yyerror("error: auth without auth table");
					YYERROR;
				}
			}
		}
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1238 "../../smtpd/parse.y"
    { (yyval.v.number) = 1; }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1239 "../../smtpd/parse.y"
    { (yyval.v.number) = 0; }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1242 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(4) - (4)].v.table);

			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			if (!table_check_use(t, T_DYNAMIC|T_LIST, K_NETADDR)) {
				yyerror("invalid use of table \"%s\" as FROM parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notsources = (yyvsp[(2) - (4)].v.number);
			rule->r_sources = t;
		}
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1257 "../../smtpd/parse.y"
    {
			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			rule->r_sources = table_find("<anyhost>", NULL);
			rule->r_notsources = (yyvsp[(2) - (3)].v.number);
		}
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1265 "../../smtpd/parse.y"
    {
			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			rule->r_sources = table_find("<localhost>", NULL);
			rule->r_notsources = (yyvsp[(2) - (3)].v.number);
		}
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1275 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(4) - (4)].v.table);

			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
				yyerror("invalid use of table \"%s\" as DOMAIN parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[(2) - (4)].v.number);
			rule->r_destination = t;
		}
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1290 "../../smtpd/parse.y"
    {
			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[(2) - (3)].v.number);
			rule->r_destination = table_find("<anydestination>", NULL);
		}
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1298 "../../smtpd/parse.y"
    {
			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[(2) - (3)].v.number);
			rule->r_destination = table_find("<localnames>", NULL);
		}
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 1308 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(3) - (3)].v.table);

			if (rule->r_senders) {
				yyerror("sender specified multiple times");
				YYERROR;
			}

			if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
				yyerror("invalid use of table \"%s\" as SENDER parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notsenders = (yyvsp[(2) - (3)].v.number);
			rule->r_senders = t;
		}
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1326 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(3) - (3)].v.table);

			if (rule->r_recipients) {
				yyerror("recipient specified multiple times");
				YYERROR;
			}

			if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
				yyerror("invalid use of table \"%s\" as RECIPIENT parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notrecipients = (yyvsp[(2) - (3)].v.number);
			rule->r_recipients = t;
		}
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1344 "../../smtpd/parse.y"
    {
			if (rule->r_forwardonly) {
				yyerror("forward-only specified multiple times");
				YYERROR;
			}
			rule->r_forwardonly = 1;
		}
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 1353 "../../smtpd/parse.y"
    {
			if (rule->r_qexpire != -1) {
				yyerror("expire specified multiple times");
				YYERROR;
			}
			rule->r_qexpire = delaytonum((yyvsp[(2) - (2)].v.string));
			if (rule->r_qexpire == -1) {
				yyerror("invalid expire delay: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1398 "../../smtpd/parse.y"
    {
			rule = xcalloc(1, sizeof(*rule), "parse rule: ACCEPT");
			rule->r_action = A_NONE;
			rule->r_decision = R_ACCEPT;
			rule->r_desttype = DEST_DOM;
			rule->r_qexpire = -1;
		}
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1404 "../../smtpd/parse.y"
    {
			if (!rule->r_sources)
				rule->r_sources = table_find("<localhost>", NULL);
			if (!rule->r_destination)
			 	rule->r_destination = table_find("<localnames>", NULL);
			if (!rule->r_userbase)
				rule->r_userbase = table_find("<getpwnam>", NULL);
			if (rule->r_qexpire == -1)
				rule->r_qexpire = conf->sc_qexpire;
			if (rule->r_action == A_RELAY || rule->r_action == A_RELAYVIA) {
				if (rule->r_userbase != table_find("<getpwnam>", NULL)) {
					yyerror("userbase may not be used with a relay rule");
					YYERROR;
				}
				if (rule->r_mapping) {
					yyerror("aliases/virtual may not be used with a relay rule");
					YYERROR;
				}
			}
			if (rule->r_forwardonly && rule->r_action != A_NONE) {
				yyerror("forward-only may not be used with a default action");
				YYERROR;
			}
			TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
			rule = NULL;
		}
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 1430 "../../smtpd/parse.y"
    {
			rule = xcalloc(1, sizeof(*rule), "parse rule: REJECT");
			rule->r_decision = R_REJECT;
			rule->r_desttype = DEST_DOM;
		}
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1434 "../../smtpd/parse.y"
    {
			if (!rule->r_sources)
				rule->r_sources = table_find("<localhost>", NULL);
			if (!rule->r_destination)
				rule->r_destination = table_find("<localnames>", NULL);
			TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
			rule = NULL;
		}
    break;


/* Line 1792 of yacc.c  */
#line 3572 "../../smtpd/parse.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 1443 "../../smtpd/parse.y"


struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list		 ap;
	char		*msg;

	file->errors++;
	va_start(ap, fmt);
	if (vasprintf(&msg, fmt, ap) == -1)
		fatalx("yyerror vasprintf");
	va_end(ap);
	logit(LOG_CRIT, "%s:%d: %s", file->name, yylval.lineno, msg);
	free(msg);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "accept",		ACCEPT },
		{ "alias",		ALIAS },
		{ "any",		ANY },
		{ "as",			AS },
		{ "auth",		AUTH },
		{ "auth-optional",     	AUTH_OPTIONAL },
		{ "backup",		BACKUP },
		{ "bounce-warn",	BOUNCEWARN },
		{ "ca",			CA },
		{ "certificate",	CERTIFICATE },
		{ "ciphers",		CIPHERS },
		{ "compression",	COMPRESSION },
		{ "deliver",		DELIVER },
		{ "dhe",		DHE },
		{ "domain",		DOMAIN },
		{ "encryption",		ENCRYPTION },
		{ "expire",		EXPIRE },
		{ "filter",		FILTER },
		{ "for",		FOR },
		{ "forward-only",      	FORWARDONLY },
		{ "from",		FROM },
		{ "hostname",		HOSTNAME },
		{ "hostnames",		HOSTNAMES },
		{ "include",		INCLUDE },
		{ "inet4",		INET4 },
		{ "inet6",		INET6 },
		{ "key",		KEY },
		{ "limit",		LIMIT },
		{ "listen",		LISTEN },
		{ "lmtp",		LMTP },
		{ "local",		LOCAL },
		{ "maildir",		MAILDIR },
		{ "mask-source",	MASK_SOURCE },
		{ "masquerade",		MASQUERADE },
		{ "max-message-size",  	MAXMESSAGESIZE },
		{ "max-mta-deferred",  	MAXMTADEFERRED },
		{ "mbox",		MBOX },
		{ "mda",		MDA },
		{ "mta",		MTA },
		{ "no-dsn",		NODSN },
		{ "on",			ON },
		{ "pki",		PKI },
		{ "port",		PORT },
		{ "queue",		QUEUE },
		{ "rcpt-to",		RCPTTO },
		{ "received-auth",     	RECEIVEDAUTH },
		{ "recipient",		RECIPIENT },
		{ "reject",		REJECT },
		{ "relay",		RELAY },
		{ "scheduler",		SCHEDULER },
		{ "secure",		SECURE },
		{ "sender",    		SENDER },
		{ "senders",   		SENDERS },
		{ "session",   		SESSION },
		{ "smtps",		SMTPS },
		{ "socket",		SOCKET },
		{ "source",		SOURCE },
		{ "table",		TABLE },
		{ "tag",		TAG },
		{ "tagged",		TAGGED },
		{ "tls",		TLS },
		{ "tls-require",       	TLS_REQUIRE },
		{ "to",			TO },
		{ "userbase",		USERBASE },
		{ "verify",		VERIFY },
		{ "via",		VIA },
		{ "virtual",		VIRTUAL },
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define MAXPUSHBACK	128

unsigned char	*parsebuf;
int		 parseindex;
unsigned char	 pushback_buffer[MAXPUSHBACK];
int		 pushback_index = 0;

int
lgetc(int quotec)
{
	int		c, next;

	if (parsebuf) {
		/* Read character from the parsebuffer instead of input. */
		if (parseindex >= 0) {
			c = parsebuf[parseindex++];
			if (c != '\0')
				return (c);
			parsebuf = NULL;
		} else
			parseindex++;
	}

	if (pushback_index)
		return (pushback_buffer[--pushback_index]);

	if (quotec) {
		if ((c = getc(file->stream)) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = getc(file->stream)) == '\\') {
		next = getc(file->stream);
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	while (c == EOF) {
		if (file == topfile || popfile() == EOF)
			return (EOF);
		c = getc(file->stream);
	}
	return (c);
}

int
lungetc(int c)
{
	if (c == EOF)
		return (EOF);
	if (parsebuf) {
		parseindex--;
		if (parseindex >= 0)
			return (c);
	}
	if (pushback_index < MAXPUSHBACK-1)
		return (pushback_buffer[pushback_index++] = c);
	else
		return (EOF);
}

int
findeol(void)
{
	int	c;

	parsebuf = NULL;
	pushback_index = 0;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	unsigned char	 buf[8096];
	unsigned char	*p, *val;
	int		 quotec, next, c;
	int		 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && parsebuf == NULL) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		parsebuf = val;
		parseindex = 0;
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || c == ' ' || c == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			} else if (c == '\0') {
				yyerror("syntax error");
				return (findeol());
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "yylex: strdup");
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc(*--p);
			c = *--p;
			if (c == '-')
				return (c);
		}
	}

	if (c == '=') {
		if ((c = lgetc(0)) != EOF && c == '>')
			return (ARROW);
		lungetc(c);
		c = '=';
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '#' && \
	x != ','))

	if (isalnum(c) || c == ':' || c == '_') {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "yylex: strdup");
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		log_warn("warn: cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		log_warnx("warn: %s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IWGRP | S_IXGRP | S_IRWXO)) {
		log_warnx("warn: %s: group/world readable/writeable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		log_warn("warn: malloc");
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		log_warn("warn: malloc");
		free(nfile);
		return (NULL);
	}
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		log_warn("warn: %s", nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = 1;
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

int
parse_config(struct smtpd *x_conf, const char *filename, int opts)
{
	struct sym     *sym, *next;
	struct table   *t;
	char		hostname[HOST_NAME_MAX+1];
	char		hostname_copy[HOST_NAME_MAX+1];

	if (getmailname(hostname, sizeof hostname) == -1)
		return (-1);

	conf = x_conf;
	memset(conf, 0, sizeof(*conf));

	(void)strlcpy(conf->sc_hostname, hostname, sizeof(conf->sc_hostname));

	conf->sc_maxsize = DEFAULT_MAX_BODY_SIZE;

	conf->sc_tables_dict = calloc(1, sizeof(*conf->sc_tables_dict));
	conf->sc_rules = calloc(1, sizeof(*conf->sc_rules));
	conf->sc_listeners = calloc(1, sizeof(*conf->sc_listeners));
	conf->sc_ca_dict = calloc(1, sizeof(*conf->sc_ca_dict));
	conf->sc_pki_dict = calloc(1, sizeof(*conf->sc_pki_dict));
	conf->sc_ssl_dict = calloc(1, sizeof(*conf->sc_ssl_dict));
	conf->sc_limits_dict = calloc(1, sizeof(*conf->sc_limits_dict));

	/* Report mails delayed for more than 4 hours */
	conf->sc_bounce_warn[0] = 3600 * 4;

	if (conf->sc_tables_dict == NULL	||
	    conf->sc_rules == NULL		||
	    conf->sc_listeners == NULL		||
	    conf->sc_ca_dict == NULL		||
	    conf->sc_pki_dict == NULL		||
	    conf->sc_ssl_dict == NULL		||
	    conf->sc_limits_dict == NULL) {
		log_warn("warn: cannot allocate memory");
		free(conf->sc_tables_dict);
		free(conf->sc_rules);
		free(conf->sc_listeners);
		free(conf->sc_ca_dict);
		free(conf->sc_pki_dict);
		free(conf->sc_ssl_dict);
		free(conf->sc_limits_dict);
		return (-1);
	}

	errors = 0;

	table = NULL;
	rule = NULL;

	dict_init(&conf->sc_filters);

	dict_init(conf->sc_ca_dict);
	dict_init(conf->sc_pki_dict);
	dict_init(conf->sc_ssl_dict);
	dict_init(conf->sc_tables_dict);

	dict_init(conf->sc_limits_dict);
	limits = xcalloc(1, sizeof(*limits), "mta_limits");
	limit_mta_set_defaults(limits);
	dict_xset(conf->sc_limits_dict, "default", limits);

	TAILQ_INIT(conf->sc_listeners);
	TAILQ_INIT(conf->sc_rules);

	conf->sc_qexpire = SMTPD_QUEUE_EXPIRY;
	conf->sc_opts = opts;

	conf->sc_mta_max_deferred = 100;
	conf->sc_scheduler_max_inflight = 5000;
	conf->sc_scheduler_max_schedule = 10;
	conf->sc_scheduler_max_evp_batch_size = 256;
	conf->sc_scheduler_max_msg_batch_size = 1024;
	
	conf->sc_session_max_rcpt = 1000;
	conf->sc_session_max_mails = 100;

	conf->sc_mda_max_session = 50;
	conf->sc_mda_max_user_session = 7;
	conf->sc_mda_task_hiwat = 50;
	conf->sc_mda_task_lowat = 30;
	conf->sc_mda_task_release = 10;

	if ((file = pushfile(filename, 0)) == NULL) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}
	topfile = file;

	/*
	 * declare special "localhost", "anyhost" and "localnames" tables
	 */
	set_local(hostname);

	t = table_create("static", "<anydestination>", NULL, NULL);
	t->t_type = T_LIST;
	table_add(t, "*", NULL);

	/* can't truncate here */
	(void)strlcpy(hostname_copy, hostname, sizeof hostname_copy);

	hostname_copy[strcspn(hostname_copy, ".")] = '\0';
	if (strcmp(hostname, hostname_copy) != 0)
		table_add(t, hostname_copy, NULL);

	table_create("getpwnam", "<getpwnam>", NULL, NULL);

	/*
	 * parse configuration
	 */
	setservent(1);
	yyparse();
	errors = file->errors;
	popfile();
	endservent();

	/* If the socket listener was not configured, create a default one. */
	if (!conf->sc_sock_listener) {
		memset(&listen_opts, 0, sizeof listen_opts);
		conf->sc_sock_listener = create_sock_listener(&listen_opts);
	}

	/* Free macros and check which have not been used. */
	for (sym = TAILQ_FIRST(&symhead); sym != NULL; sym = next) {
		next = TAILQ_NEXT(sym, entry);
		if ((conf->sc_opts & SMTPD_OPT_VERBOSE) && !sym->used)
			fprintf(stderr, "warning: macro '%s' not "
			    "used\n", sym->nam);
		if (!sym->persist) {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}

	if (TAILQ_EMPTY(conf->sc_rules)) {
		log_warnx("warn: no rules, nothing to do");
		errors++;
	}

	if (errors) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}

	return (0);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	for (sym = TAILQ_FIRST(&symhead); sym && strcmp(nam, sym->nam);
	    sym = TAILQ_NEXT(sym, entry))
		;	/* nothing */

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;
	size_t	len;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);

	len = strlen(s) - strlen(val) + 1;
	if ((sym = malloc(len)) == NULL)
		errx(1, "cmdline_symset: malloc");

	(void)strlcpy(sym, s, len);

	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry)
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	return (NULL);
}

static struct listener *
create_sock_listener(struct listen_opts *lo)
{
	struct listener *l = xcalloc(1, sizeof(*l), "create_sock_listener");
	lo->tag = "local";
	lo->hostname = conf->sc_hostname;
	l->ss.ss_family = AF_LOCAL;
#ifdef HAVE_STRUCT_SOCKADDR_STORAGE_SS_LEN
	l->ss.ss_len = sizeof(struct sockaddr *);
#endif
	l->local = 1;
	config_listener(l, lo);

	return (l);
}

static void
create_if_listener(struct listenerlist *ll,  struct listen_opts *lo)
{
	uint16_t	flags;

	if (lo->port != 0 && lo->ssl == F_SSL)
		errx(1, "invalid listen option: tls/smtps on same port");

	if (lo->auth != 0 && !lo->ssl)
		errx(1, "invalid listen option: auth requires tls/smtps");

	if (lo->pki && !lo->ssl)
		errx(1, "invalid listen option: pki requires tls/smtps");

	flags = lo->flags;

	if (lo->port) {
		lo->flags = lo->ssl|lo->auth|flags;
		lo->port = htons(lo->port);
		if (!interface(ll, lo))
			if (host(ll, lo) <= 0)
				errx(1, "invalid virtual ip or interface: %s", lo->ifx);
	}
	else {
		if (lo->ssl & F_SMTPS) {
			lo->port = htons(465);
			lo->flags = F_SMTPS|lo->auth|flags;
			if (!interface(ll, lo))
				if (host(ll, lo) <= 0)
					errx(1, "invalid virtual ip or interface: %s", lo->ifx);
		}

		if (!lo->ssl || (lo->ssl & F_STARTTLS)) {
			lo->port = htons(25);
			lo->flags = lo->auth|flags;
			if (lo->ssl & F_STARTTLS)
				lo->flags |= F_STARTTLS;
			if (!interface(ll, lo))
				if (host(ll, lo) <= 0)
					errx(1, "invalid virtual ip or interface: %s", lo->ifx);
		}
	}
}

static void
config_listener(struct listener *h,  struct listen_opts *lo)
{
	h->fd = -1;
	h->port = lo->port;
	h->flags = lo->flags;

	if (lo->hostname == NULL)
		lo->hostname = conf->sc_hostname;

	if (lo->filtername) {
		if (dict_get(&conf->sc_filters, lo->filtername) == NULL) {
			log_warnx("undefined filter: %s", lo->filtername);
			fatalx(NULL);
		}
		(void)strlcpy(h->filter, lo->filtername, sizeof(h->filter));
	}

	h->pki_name[0] = '\0';

	if (lo->authtable != NULL)
		(void)strlcpy(h->authtable, lo->authtable->t_name, sizeof(h->authtable));
	if (lo->pki != NULL) {
		if (!lowercase(h->pki_name, lo->pki, sizeof(h->pki_name))) {
			log_warnx("pki name too long: %s", lo->pki);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_pki_dict, h->pki_name) == NULL) {
			log_warnx("pki name not found: %s", lo->pki);
			fatalx(NULL);
		}
	}

	if (lo->ca != NULL) {
		if (!lowercase(h->ca_name, lo->ca, sizeof(h->ca_name))) {
			log_warnx("ca name too long: %s", lo->ca);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_ca_dict, h->ca_name) == NULL) {
			log_warnx("ca name not found: %s", lo->ca);
			fatalx(NULL);
		}
	}
	if (lo->tag != NULL)
		(void)strlcpy(h->tag, lo->tag, sizeof(h->tag));

	(void)strlcpy(h->hostname, lo->hostname, sizeof(h->hostname));
	if (lo->hostnametable)
		(void)strlcpy(h->hostnametable, lo->hostnametable->t_name, sizeof(h->hostnametable));
	if (lo->sendertable) {
		(void)strlcpy(h->sendertable, lo->sendertable->t_name, sizeof(h->sendertable));
		if (lo->options & LO_MASQUERADE)
			h->flags |= F_MASQUERADE;
	}

	if (lo->ssl & F_TLS_VERIFY)
		h->flags |= F_TLS_VERIFY;
}

struct listener *
host_v4(const char *s, in_port_t port)
{
	struct in_addr		 ina;
	struct sockaddr_in	*sain;
	struct listener		*h;

	memset(&ina, 0, sizeof(ina));
	if (inet_pton(AF_INET, s, &ina) != 1)
		return (NULL);

	h = xcalloc(1, sizeof(*h), "host_v4");
	sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
	sain->sin_len = sizeof(struct sockaddr_in);
#endif
	sain->sin_family = AF_INET;
	sain->sin_addr.s_addr = ina.s_addr;
	sain->sin_port = port;

	if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
		h->local = 1;

	return (h);
}

struct listener *
host_v6(const char *s, in_port_t port)
{
	struct in6_addr		 ina6;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&ina6, 0, sizeof(ina6));
	if (inet_pton(AF_INET6, s, &ina6) != 1)
		return (NULL);

	h = xcalloc(1, sizeof(*h), "host_v6");
	sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
	sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
	sin6->sin6_family = AF_INET6;
	sin6->sin6_port = port;
	memcpy(&sin6->sin6_addr, &ina6, sizeof(ina6));

	if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
		h->local = 1;

	return (h);
}

int
host_dns(struct listenerlist *al, struct listen_opts *lo)
{
	struct addrinfo		 hints, *res0, *res;
	int			 error, cnt = 0;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = PF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_flags = AI_ADDRCONFIG;
	error = getaddrinfo(lo->ifx, NULL, &hints, &res0);
	if (error == EAI_AGAIN || error == EAI_NODATA || error == EAI_NONAME)
		return (0);
	if (error) {
		log_warnx("warn: host_dns: could not parse \"%s\": %s", lo->ifx,
		    gai_strerror(error));
		return (-1);
	}

	for (res = res0; res; res = res->ai_next) {
		if (res->ai_family != AF_INET &&
		    res->ai_family != AF_INET6)
			continue;
		h = xcalloc(1, sizeof(*h), "host_dns");

		h->ss.ss_family = res->ai_family;
		if (res->ai_family == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    res->ai_addr)->sin_addr.s_addr;
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    res->ai_addr)->sin6_addr, sizeof(struct in6_addr));
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
		}

		config_listener(h, lo);

		TAILQ_INSERT_HEAD(al, h, entry);
		cnt++;
	}

	freeaddrinfo(res0);
	return (cnt);
}

int
host(struct listenerlist *al, struct listen_opts *lo)
{
	struct listener *h;

	h = host_v4(lo->ifx, lo->port);

	/* IPv6 address? */
	if (h == NULL)
		h = host_v6(lo->ifx, lo->port);

	if (h != NULL) {
		config_listener(h, lo);
		TAILQ_INSERT_HEAD(al, h, entry);
		return (1);
	}

	return (host_dns(al, lo));
}

int
interface(struct listenerlist *al, struct listen_opts *lo)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;
	int			ret = 0;

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		if (strcmp(p->ifa_name, lo->ifx) != 0 &&
		    !is_if_in_group(p->ifa_name, lo->ifx))
			continue;
		if (lo->family != AF_UNSPEC && lo->family != p->ifa_addr->sa_family)
			continue;

		h = xcalloc(1, sizeof(*h), "interface");

		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&h->ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&h->ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
			break;

		default:
			free(h);
			continue;
		}

		config_listener(h, lo);
		ret = 1;
		TAILQ_INSERT_HEAD(al, h, entry);
	}

	freeifaddrs(ifap);

	return ret;
}

void
set_local(const char *hostname)
{
	struct table	*t;

	t = table_create("static", "<localnames>", NULL, NULL);
	t->t_type = T_LIST;
	table_add(t, "localhost", NULL);
	table_add(t, hostname, NULL);

	set_localaddrs(t);
}

void
set_localaddrs(struct table *localnames)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_storage ss;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct table		*t;
	char buf[NI_MAXHOST + 5];

	t = table_create("static", "<anyhost>", NULL, NULL);
	table_add(t, "local", NULL);
	table_add(t, "0.0.0.0/0", NULL);
	table_add(t, "::/0", NULL);

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	t = table_create("static", "<localhost>", NULL, NULL);
	table_add(t, "local", NULL);

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			table_add(t, ss_to_text(&ss), NULL);
			table_add(localnames, ss_to_text(&ss), NULL);
			(void)snprintf(buf, sizeof buf, "[%s]", ss_to_text(&ss));
			table_add(localnames, buf, NULL);
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			table_add(t, ss_to_text(&ss), NULL);
			table_add(localnames, ss_to_text(&ss), NULL);
			(void)snprintf(buf, sizeof buf, "[%s]", ss_to_text(&ss));
			table_add(localnames, buf, NULL);
			(void)snprintf(buf, sizeof buf, "[ipv6:%s]", ss_to_text(&ss));
			table_add(localnames, buf, NULL);
			break;
		}
	}

	freeifaddrs(ifap);
}

int
delaytonum(char *str)
{
	unsigned int     factor;
	size_t           len;
	const char      *errstr = NULL;
	int              delay;

	/* we need at least 1 digit and 1 unit */
	len = strlen(str);
	if (len < 2)
		goto bad;

	switch(str[len - 1]) {

	case 's':
		factor = 1;
		break;

	case 'm':
		factor = 60;
		break;

	case 'h':
		factor = 60 * 60;
		break;

	case 'd':
		factor = 24 * 60 * 60;
		break;

	default:
		goto bad;
	}

	str[len - 1] = '\0';
	delay = strtonum(str, 1, INT_MAX / factor, &errstr);
	if (errstr)
		goto bad;

	return (delay * factor);

bad:
	return (-1);
}

int
is_if_in_group(const char *ifname, const char *groupname)
{
#ifdef HAVE_STRUCT_IFGROUPREQ
        unsigned int		 len;
        struct ifgroupreq        ifgr;
        struct ifg_req          *ifg;
	int			 s;
	int			 ret = 0;

	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		err(1, "socket");

        memset(&ifgr, 0, sizeof(ifgr));
        if (strlcpy(ifgr.ifgr_name, ifname, IFNAMSIZ) >= IFNAMSIZ)
		errx(1, "interface name too large");

        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1) {
                if (errno == EINVAL || errno == ENOTTY)
			goto end;
		err(1, "SIOCGIFGROUP");
        }

        len = ifgr.ifgr_len;
        ifgr.ifgr_groups = xcalloc(len/sizeof(struct ifg_req),
		sizeof(struct ifg_req), "is_if_in_group");
        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1)
                err(1, "SIOCGIFGROUP");

        ifg = ifgr.ifgr_groups;
        for (; ifg && len >= sizeof(struct ifg_req); ifg++) {
                len -= sizeof(struct ifg_req);
		if (strcmp(ifg->ifgrq_group, groupname) == 0) {
			ret = 1;
			break;
		}
        }
        free(ifgr.ifgr_groups);

end:
	close(s);
	return ret;
#else
	return (0);
#endif
}

static struct filter_conf *
create_filter_proc(char *name, char *prog)
{
	struct filter_conf	*f;
	char			*path;

	if (dict_get(&conf->sc_filters, name)) {
		yyerror("filter \"%s\" already defined", name);
		return (NULL);
	}

	if (asprintf(&path, "%s/filter-%s", PATH_LIBEXEC, prog) == -1) {
		yyerror("filter \"%s\" asprintf failed", name);
		return (0);
	}

	f = xcalloc(1, sizeof(*f), "create_filter");
	f->path = path;
	f->name = name;
	f->argv[f->argc++] = name;

	dict_xset(&conf->sc_filters, name, f);

	return (f);
}

static struct filter_conf *
create_filter_chain(char *name)
{
	struct filter_conf	*f;

	if (dict_get(&conf->sc_filters, name)) {
		yyerror("filter \"%s\" already defined", name);
		return (NULL);
	}

	f = xcalloc(1, sizeof(*f), "create_filter_chain");
	f->chain = 1;
	f->name = name;

	dict_xset(&conf->sc_filters, name, f);

	return (f);
}

static int
add_filter_arg(struct filter_conf *f, char *arg)
{
	int	i;

	if (f->argc == MAX_FILTER_ARGS) {
		yyerror("filter \"%s\" is full", f->name);
		return (0);
	}

	if (f->chain) {
		if (dict_get(&conf->sc_filters, arg) == NULL) {
			yyerror("undefined filter \"%s\"", arg);
			return (0);
		}
		if (dict_get(&conf->sc_filters, arg) == f) {
			yyerror("filter chain cannot contain itself");
			return (0);
		}
		for (i = 0; i < f->argc; ++i)
			if (strcasecmp(f->argv[i], arg) == 0) {
				yyerror("filter chain cannot contain twice the same filter instance");
				return (0);
			}
	}

	f->argv[f->argc++] = arg;

	return (1);
}

static int
config_lo_filter(struct listen_opts *lo, char *filter_name) {
	if (lo->options & LO_FILTER) {
		yyerror("filter already specified");
		return -1;
	}
	lo->options |= LO_FILTER;
	lo->filtername = filter_name;

	return 0;
}

static int
config_lo_mask_source(struct listen_opts *lo) {
	if (lo->options & LO_MASKSOURCE) {
		yyerror("mask-source already specified");
		return -1;
	}
	lo->options |= LO_MASKSOURCE;
	lo->flags |= F_MASK_SOURCE;

	return 0;
}

